;;======================================================================================*
;;											*
;;              Project		:	NATIVE SPIRIT					*
;;		FILENAME	:	Packed.inc					*
;;              Function	:	Ice Packed Address Definitions		 	*
;;											*
;;			COPYRIGHT 1996,1997,1998 Duranik Software			*
;;		  UNAUTHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION,			*
;;		   PERFORMANCE OR DISPLAY OF THIS COMPUTER PROGRAM OR			*
;;		 THE ASSOCIATED AUDIOVISUAL WORK IS STRICTLY PROHIBITED.		*
;;				    ALL RIGHTS RESERVED.				*
;;											*
;;		REV.	DATE		AUTHOR		REVISION HISTORY		*
;;		~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~~~~~~~~~~		*
;;		000	04-13-98	DURANIK		Packed.inc Original		*
;;		002	12-18-07	Zentanyx	Packed.inc 2nd Revision		*
;;											*
;;		Modification and Anomaly Report						*
;;		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~					*
;;		* scrapped bonus/bkgd/trim images & redefined those in use		*
;;		* junojkd size changed							*
;;											*
;;		   NATIVE SPIRIT Adaptation Produced by Jason Keith Data		*
;;	   This Revision has been released under an Educational Community License	*
;;				Copyright  2007 Zentanyx				*
;;											*
;;======================================================================================*

grafic_end	EQU	ENDRAM-1024-(88*320*4)
grafic_end1	EQU	grafic_end-1024		; wegen Fehler in Spiegel routine

;;;==============================================
;;; Last Addrs (-) CRY image size FROM last image
;;;==============================================

arc		EQU	grafic_end1-20480	; Shield Surround (rak_l40-20480)
anzeige		EQU	arc-14592		; Powerbar? (bonus_o-14592)
energy		EQU	anzeige-2048		; Anzeige Energie
zahlen1		EQU	energy-1280		; Ranger 1 Score?
zahlen		EQU	zahlen1-1280		; High Score
zahlen2		EQU	zahlen-1760		; Ranger 2 Score?
anzeige1	EQU	zahlen2-5120		; Anzeige Beamstrike
rocket		EQU	anzeige1-432		; Enemy Rocket?
treffer		EQU	rocket-11520		; Rocket o-ring trail
gegners1	EQU	treffer-2880		; Enemy Fireball

NBLR3JKD	EQU	gegners1-19456		; REV001 Starship Sprite (21888)
geld		EQU	NBLR3JKD-7680		; REV002 TKN1JKD
geld2		EQU	geld-7680		; REV002 TKN2JKD

beam6		EQU	geld2-2040		; Plasma Beam 6
beam5		EQU	beam6-1456		; Plasma Beam 5
beam4		EQU	beam5-880		; Plasma Beam 4
beam3		EQU	beam4-576		; Plasma Beam 3
beam2		EQU	beam3-240		; Plasma Beam 2
beam1		EQU	beam2-160		; Plasma Beam 1
beam_s		EQU	beam1-2600		; Anzeige (powerbar?) for Beamstrike
schuss1		EQU	beam_s-192		; Regular Plasma Bolt
tr6		EQU	schuss1-2880		; Hull debris 6
tr5		EQU	tr6-7920		; Hull debris 5
tr4		EQU	tr5-3360		; Hull debris 4
tr3		EQU	tr4-8160		; Hull debris 3
tr2		EQU	tr3-6720		; Hull debris 2
tr1		EQU	tr2-3120		; Hull debris 1
explo		EQU	tr1-152640		; Explosion
rocket_b	EQU	explo-792		; Enemy Rockets

whnNASA		EQU	rocket_b-163840 	; REV001 whnNASA 163840cry 128406ice (nebula 163840)

meteor_1	EQU	whnNASA-46592		; ASTEROID (baut3_n-46592)
s_cra		EQU	meteor_1-8624		; Chevron Formation Ships

renNASA		EQU	s_cra-30720		; REV001 Rotten Egg Nebula (lens 28800)

lens1		EQU	renNASA-3200		; Flare
lens2		EQU	lens1-2048		; Flare
leiter_f	EQU	lens2-67584		; Foreground Antenna
leiterbs	EQU	leiter_f-20480		; Foreground Antenna
schutz		EQU	leiterbs-20480		; Striped metal ball
b_mike		EQU	schutz-19840		; StarBugs
leiterq1	EQU	b_mike-11200		; Foreground Antenna

RylosJKD	EQU	leiterq1-25088		; REV001 Rylos 25088cry 12894ice (Planet-35568)

rotg		EQU	RylosJKD-36000		; rotating rocket throwers (wurm2-36000)
ball		EQU	rotg-3200		; blue golfballs
spike		EQU	ball-3200		; red spores
resort		EQU	spike-16000		; twisted helix serpent (runner_j-16000)

; ********* SCRAPS *****************************
;;;rak_l40		EQU	grafic_end1-480
;;;stern		EQU	arc-24576
;;;bonus_x		EQU	stern-10240
;;;bonus_o		EQU	bonus_x-10240
;
;;;baut3_n		EQU	whnNASA-7040
;;;baut1_n		EQU	RylosJKD-32000
;;;baut2_n		EQU	baut1_n-26880
;
;;;back1		EQU	(ENDRAM/2)-80608;-165368; necessary diagrams and diagrams not needed
;;;teil6		EQU	back1+163840
;;;teil1		EQU	teil6+15360
;;;teil0		EQU	teil1+25600
;;;nebel		EQU	teil0+56320
;;;zahn_gross		EQU	nebel+29440+512	; + Farbpalette 
;;;zahn_klein		EQU	zahn_gross+38912
;;;back0		EQU	crawler+26400
;;;ape2			EQU	back0+88064
;;;gesch1		EQU	q_bomb+2448
;;;gesch1k		EQU	gesch1+21600
;
;;;teil5		EQU	rocket_b-44800
;;;eye			EQU	teil5-3200
;;;gasglas		EQU	eye-63280
;;;haltglas		EQU	gasglas-7488
;;;hugger		EQU	haltglas-54400
;;;glas			EQU	hugger-6080
;;;wurm			EQU	glas-6000
;;;wurm2		EQU	wurm-69600
;;;ape			EQU	spike-67680
;
;;;teil3		EQU	nebel+29440
;;;teil4		EQU	teil3+35840
;;;teil3b		EQU	teil4+40960
;;;m_end_li		EQU	point+17920
;;;pleuel_2		EQU	m_end_li+5376
;;;kolben_o		EQU	pleuel_2+32000
;;;kolben_u		EQU	kolben_o+40320
;;;m_end_re		EQU	kolben_u+41760
;;;presse_u		EQU	m_end_re+6384
;;;presse_o		EQU	presse_u+6816
;;;schlauch		EQU	presse_o+6816
;
;;;runner		EQU	rocket_b-116800
;;;runner_j		EQU	runner-35552
;;;oran_o		EQU	resort-6800
;;;oran_o_k		EQU	oran_o-680
;;;oran_u		EQU	oran_o_k-6800
;;;oran_u_k		EQU	oran_u-680

;;;==============================================
;;; Last Addrs (+) CRY image size OF LAST image
;;;==============================================

crawler		EQU	(ENDRAM/2)-80608	; large spinning formation ships (zahn_klein+15984)
q_bomb		EQU	crawler+26400		; spiked ball (ape2+48048)
point		EQU	q_bomb+2448		; shooting sphere of spheres (teil3b+35840)

;;;==============================================
;;; REV002
;;;==============================================

scrbdjkd	EQU	point+17920		; REV002 Station Identification (12480)
btnjkd		EQU	scrbdjkd+12480		; REV002 "Fire Buttons Relaunch"(2304)
pausejkd	EQU	btnjkd+2304		; REV002 "PAUSED" 		(9856)
mercjkd		EQU	pausejkd+9856		; REV002 Planet Mercury		(2664)
venusjkd	EQU	mercjkd+2664		; REV002 Planet Venus		(9248)
earthjkd	EQU	venusjkd+9248		; REV002 Planet Earth		(20000)
marsjkd		EQU	earthjkd+20000		; REV002 Planet Mars		(4608)
vestajkd	EQU	marsjkd+4608		; REV002 Minor Planet Vesta 	(9248)
ceresjkd	EQU	vestajkd+9248		; REV002 Dwarf Planet Ceres 	(20000)

pallajkd	EQU	ceresjkd+20000		; REV002 Minor Planet Palla	(8192)
hygiejkd	EQU	pallajkd+8192		; REV002 Minor Planet Hygiea	(7200)
davidjkd	EQU	hygiejkd+7200		; REV002 Minor Planet Davida	(4608)
interjkd	EQU	davidjkd+4608		; REV002 Minor Planet Interamnia(3872)
junojkd		EQU	interjkd+3872		; REV002 Minor Planet Juno	(2048)

;;;==============================================
;;; NATIVE DEMO text characters
;;;==============================================
a		EQU	$120000
b		EQU	a+4560
c		EQU	b+4560
d		EQU	c+4560
e		EQU	d+4560
f		EQU	e+4560
g		EQU	f+4560
h		EQU	g+4560
i		EQU	h+4560
j		EQU	i+4560
k		EQU	j+4560
l		EQU	k+4560
m		EQU	l+4560
n		EQU	m+4560
o		EQU	n+4560
p		EQU	o+4560
q		EQU	p+4560
r		EQU	q+4560
s		EQU	r+4560
t		EQU	s+4560
u		EQU	t+4560
v		EQU	u+4560
w		EQU	v+4560
x_x		EQU	w+4560
y_y		EQU	x_x+4560
z		EQU	y_y+4560
