;;======================================================================================*
;;											*
;;			Project Name	:	NATIVE SPIRIT				*
;;			Function	:	Animation list				*
;;			FILENAME	:	ACME.s					*
;;											*
;;			Programmer	:	Roland Graf             		*
;;			Graphics	:	Johannes Graf				*
;;			Ice Decrunch	:	Gordon Gibson				*
;;											*
;;			COPYRIGHT 1996,1997,1998 Duranik Software			*
;;		  UNAUTHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION,			*
;;	  	 PERFORMANCE OR DISPLAY OF THIS COMPUTER PROGRAM OR			*
;;	 	THE ASSOCIATED AUDIOVISUAL WORK IS STRICTLY PROHIBITED.			*
;;				    ALL RIGHTS RESERVED.				*
;;											*
;;		REV.	DATE		AUTHOR		REVISION HISTORY		*
;;		~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~~~~~~~~~~		*
;;		000	11-12-96	DURANIK		L1_daten.s 1st Release		*
;;		002	12-17-07	Zentanyx	ACME.s	 2nd Revision		*
;;											*
;;	Modification and Anomaly Report							*
;;	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~						*
;;	* Acme.s replaced L1_daten.s							*
;;	* Additions: Mercury, Venus, Earth, Mars, Ceres, Vesta, Pallas, Hygiea, Davida	*
;;			Interamnia, and Juno						*
;;											*
;;		   NATIVE SPIRIT Adaptation Produced by Jason Keith Data		*
;;	   This revision has been released under an Educational Community License	*
;;				Copyright  2007 Zentanyx				*
;;											*
;;======================================================================================*

;	.QPHRASE
;back0_anim:
;	dc.l	back0
;	dc.l	0		; Ende Animationsliste

	.QPHRASE
mercjkd_anim:
	dc.l	mercjkd		; Mercury
	dc.l	0		; Ende Animationsliste
	.QPHRASE
venusjkd_anim:
	dc.l	venusjkd	; Venus
	dc.l	0		; Ende Animationsliste
	.QPHRASE
earthjkd_anim:
	dc.l	earthjkd	; Earth
	dc.l	0		; Ende Animationsliste
	.QPHRASE
marsjkd_anim:
	dc.l	marsjkd		; Mars
	dc.l	0		; Ende Animationsliste
	.QPHRASE
vestajkd_anim:
	dc.l	vestajkd	; V-Type Minor Planet
	dc.l	0		; Ende Animationsliste
	.QPHRASE
ceresjkd_anim:
	dc.l	ceresjkd	; C-Type Dwarf Planet
	dc.l	0		; Ende Animationsliste

	.QPHRASE
pallajkd_anim:
	dc.l	pallajkd	; C-Type Minor Planet
	dc.l	0		; Ende Animationsliste
	.QPHRASE
hygiejkd_anim:
	dc.l	hygiejkd	; C-Type Minor Planet
	dc.l	0		; Ende Animationsliste
	.QPHRASE
davidjkd_anim:
	dc.l	davidjkd	; C-Type Minor Planet
	dc.l	0		; Ende Animationsliste
	.QPHRASE
interjkd_anim:
	dc.l	interjkd	; F-Type Minor Planet
	dc.l	0		; Ende Animationsliste
	.QPHRASE
junojkd_anim:
	dc.l	junojkd		; S-Type Minor Planet
	dc.l	0		; Ende Animationsliste


	.QPHRASE
planet_anim:
	dc.l	RylosJKD	; Planetoid Placeholder
	dc.l	0		; Ende Animationsliste
	
	.QPHRASE
bright_anim:
.i	set	0
	rept	65
	dc.l	bright+.i
.i	set	.i+8
	endr
	rept	36
	dc.l	bright+.i
	endr
	rept	64
	dc.l	bright+.i
.i	set	.i-8
	endr	
	rept	30
	dc.l	bright
	endr
	dc.l	0		; Ende Animationsliste	


	.QPHRASE
lens_anim:
	dc.l	renNASA
	dc.l	0		; Ende Animationsliste


	.QPHRASE
lens1_anim:
	dc.l	lens1		
	dc.l	lens1
	dc.l	0		; Ende Animationsliste

	.QPHRASE
lens2_anim:
	dc.l	lens2		
	dc.l	lens2
	dc.l	0		; Ende Animationsliste


	.QPHRASE
leiter_f_anim:
	dc.l	leiter_f		
	dc.l	leiter_f
	dc.l	0		; Ende Animationsliste


	.QPHRASE
leiterbs_anim:
	dc.l	leiterbs		
	dc.l	leiterbs
	dc.l	0		; Ende Animationsliste


	.QPHRASE
leiterq1_anim:
	dc.l	leiterq1		
	dc.l	leiterq1
	dc.l	0		; Ende Animationsliste



	.QPHRASE
s_cra_anim:
.i	set	0
	rept	7
	dc.l	s_cra+(28*22*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


schutz_anim:
.i	set	0
	rept	10
	dc.l	schutz+(32*32*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


rocket_b_anim:	
	dc.l	rocket_b
	dc.l	0
rocket_b_anim_end:
	dc.l	0		; Ende Animationsliste

b_mike_anim:
.i	set	0
	rept	10
	dc.l	b_mike+(32*31*2*.i)		
.i	set	.i+1
	endr	
	rept	9
.i	set	.i-1
	dc.l	b_mike+(32*31*2*.i)		
	endr	
	dc.l	0		; Ende Animationsliste


	.QPHRASE
meteor1_anim:
.i	set	0
	rept	26
	dc.l	meteor_1+(32*28*2*.i)
.i	set	.i+1
	endr	
	dc.l	0		; Ende Animationsliste


;	.QPHRASE	
;gesch1_anim:	
;	dc.l	gesch1+(40*54*2*4)		
;	dc.l	gesch1+(40*54*2*4)		
;	dc.l	gesch1+(40*54*2*3)
;	dc.l	gesch1+(40*54*2*3)		
;;	dc.l	gesch1+(40*54*2*2)
;	dc.l	gesch1+(40*54*2*2)
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1+(40*54*2*2)	
;	dc.l	gesch1+(40*54*2*2)
;	dc.l	gesch1+(40*54*2*3)
;	dc.l	gesch1+(40*54*2*3)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)
;	dc.l	gesch1+(40*54*2*4)		
;	dc.l	gesch1+(40*54*2*4)		
;	dc.l	gesch1+(40*54*2*3)
;	dc.l	gesch1+(40*54*2*3)		
;	dc.l	gesch1+(40*54*2*2)
;	dc.l	gesch1+(40*54*2*2)
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1+(40*54*2)
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	gesch1
;	dc.l	0		; Ende Animationsliste
;	
;	.QPHRASE
;nebel_anim:
;	dc.l	nebel		
;	dc.l	0	
	
;	.QPHRASE
;zahn_gross_anim:
;.i	set	0
;	rept 6
;	dc.l	zahn_gross+(80*80*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0


;	.QPHRASE
;zahn_gross_animback:
;.i	set	5
;	rept 6
;	dc.l	zahn_gross+(80*80*.i)		
;.i	set	.i-1
;	endr
;	dc.l	0


;--------------Zahnrad klein---------------
;	.QPHRASE
;zahn_klein_anim:
;.i	set	0
;	rept 6
;	dc.l	zahn_klein+(36*37*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0

;	.QPHRASE
;zahn_klein_animback:
;.i	set	5
;	rept 6
;	dc.l	zahn_klein+(36*37*2*.i)		
;.i	set	.i-1
;	endr
;	dc.l	0

	.QPHRASE
crawler_anim:
.i	set	0
	rept	10
	dc.l	crawler+(44*30*2*.i)
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste

;	.QPHRASE
;ape2_anim:
;.i	set	0
;	rept	13
;	dc.l	ape2+(56*33*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0		; Ende Animationsliste


	.QPHRASE	
q_bomb_anim:	
	dc.l	q_bomb		
	dc.l	0		; Ende Animationsliste


;	.QPHRASE
;haltglas_anim:
;	dc.l	haltglas		
;	dc.l	0	
	
	
;	.QPHRASE
;wurm_anim:
;	dc.l	wurm		
;	dc.l	0			
	
	
;	.QPHRASE
;gasglas_anim:
;.i	set	0
;	rept 10
;	dc.l	gasglas+(28*113*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0
	
	
;	.QPHRASE
;hugger_anim:
;.i	set	0
;	rept 10
;	dc.l	hugger+(40*68*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0	
	
	
;	.QPHRASE
;wurm2_anim:
;.i	set	0
;	rept 15
;	dc.l	wurm2+(40*58*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0		

;	.QPHRASE
;glas_anim:
;	dc.l	glas		
;	dc.l	0	
	
;	.QPHRASE
;ape_anim:
;.i	set	0
;	rept 15
;	dc.l	ape+(48*47*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0	

;	.QPHRASE
;eye_anim:
;	dc.l	eye		
;	dc.l	0		; Ende Animationsliste

	
	.QPHRASE
ball_anim:
	dc.l	ball		
	dc.l	0		; Ende Animationsliste

	
	.QPHRASE
spike_anim:
	dc.l	spike		
	dc.l	0		; Ende Animationsliste


	.QPHRASE
rotg_anim:
.i	set	0
	rept 10
	dc.l	rotg+(60*30*2*.i)		
.i	set	.i+1
	endr
	dc.l	0

;	.QPHRASE	
;kolben_o_anim:
;.i	set	0
;	rept	20
;	dc.l	kolben_o+(84*24*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0

;	.QPHRASE	
;kolben_u_anim:
;.i	set	0
;	rept	20
;	dc.l	kolben_u+(87*24*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0


;	.QPHRASE	
;pleuel_anim:
;.i	set	0
;	rept	20
;	dc.l	pleuel_2+(32*25*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0

	
;	.QPHRASE	
;m_end_li_anim:
;	dc.l	m_end_li		
;	dc.l	0

;	.QPHRASE	
;m_end_re_anim:
;	dc.l	m_end_re		
;	dc.l	0
	
	
;	.QPHRASE	
;presse_o_anim:	
;	dc.l	presse_o
;	dc.l	0

;	.QPHRASE
;presse_u_anim:	
;	dc.l	presse_u
;	dc.l	0
	
	.QPHRASE	
point_anim:
.i	set	0
	rept	10
	dc.l	point+(28*32*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste
	
	
;	.QPHRASE
;schlauch_anim:	
;	dc.l	schlauch
;	dc.l	0


;	.QPHRASE
;oran_u_anim:
;.i	set	0
;	rept 10
;	dc.l	oran_u+(20*17*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0
	
	
;	.QPHRASE
;oran_o_anim:
;.i	set	0
;	rept 10
;	dc.l	oran_o+(20*17*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0


;	.QPHRASE
;runner_anim:
;	rept 1
;	dc.l	runner+(80*73*0)
;	dc.l	runner+(80*73*1)
;	dc.l	runner+(80*73*2)		
;	dc.l	runner+(80*73*3)
;	dc.l	runner+(80*73*4)
;	dc.l	runner+(80*73*5)
;	dc.l	runner+(80*73*6)
;	dc.l	runner+(80*73*7)
;	dc.l	runner+(80*73*8)
;	dc.l	runner+(80*73*9)
;;	dc.l	runner+(80*73*10)		
;;	dc.l	runner+(80*73*11)
;	dc.l	runner+(80*73*12)
;	dc.l	runner+(80*73*13)
;	dc.l	runner+(80*73*14)
;	dc.l	runner+(80*73*15)
;	dc.l	runner+(80*73*16)
;	dc.l	runner+(80*73*17)
;;	dc.l	runner+(80*73*18)
;;	dc.l	runner+(80*73*19)
;;	endr

;	dc.l	runner+(80*73*0)
;	dc.l	runner+(80*73*1)
;	dc.l	runner+(80*73*2)		
;	dc.l	runner+(80*73*3)
;	dc.l	runner+(80*73*4)
;	dc.l	runner+(80*73*5)
	
;	dc.l	runner_j+(80*73*0)
;	dc.l	runner_j+(80*73*1)
;	dc.l	runner_j+(80*73*2)
;	dc.l	runner_j+(80*73*3)
;;	dc.l	runner_j+(80*73*4)
;	dc.l	runner_j+(80*73*5)
	
;	dc.l	runner_j+(80*73*5)
;	dc.l	runner_j+(80*73*4)
;	dc.l	runner_j+(80*73*3)
;	dc.l	runner_j+(80*73*2)
;;	dc.l	runner_j+(80*73*1)
;	dc.l	runner_j+(80*73*0)
	
;	dc.l	runner_j+(80*73*1)
;;	dc.l	runner_j+(80*73*2)
;	dc.l	runner_j+(80*73*3)
;	dc.l	runner_j+(80*73*4)
;	dc.l	runner_j+(80*73*5)
	
;	rept 80
;	dc.l	runner_j+(80*73*5)
;;	endr
;	dc.l	0


;	.QPHRASE
;runner_anim2:
;.i	set	0
;	rept 20
;	dc.l	runner+(80*73*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0
	

	.QPHRASE
resort_anim:
.i	set	0
	rept	20
	dc.l	resort+(16*25*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste

;-------------------------------------------------------------------------
; Skalierlisten
;-------------------------------------------------------------------------
	.QPHRASE
meteor2_scale:
	dc.w	 $20 			; reminder
	dc.b	  21
	dc.b	  21
	dc.l	   0 
	  

	.QPHRASE
meteor3_scale:
	dc.w	 $20 			; reminder
	dc.b	  15
	dc.b	  15
	dc.l	   0 
	  
	  
	.QPHRASE  
meteor4_scale:
	dc.w	 $20 			; reminder
	dc.b	   7
	dc.b	   7
	dc.l	   0 
	  

	.QPHRASE
lens_scale:
	dc.w    $20            ;remainder
        dc.b    6
        dc.b    6
       	dc.l	0	       ; Ende Skalierliste

	.QPHRASE
lens1_scale:
	dc.w    $20            ;remainder
        dc.b    10
        dc.b    10
       	dc.l	0	       ; Ende Skalierliste

	.QPHRASE
lens2_scale:
	dc.w    $20            ;remainder
        dc.b    17
        dc.b    17
       	dc.l	0	       ; Ende Skalierliste


	.QPHRASE
lens3_scale:
	dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
       	dc.l	0	       ; Ende Skalierliste

	
	.QPHRASE
lens5_scale:
	dc.w    $20            ;remainder
        dc.b    50
        dc.b    50
       	dc.l	0	       ; Ende Skalierliste

	
	.QPHRASE
lens6_scale:
	dc.w    $20            ;remainder
        dc.b    90
        dc.b    90
       	dc.l	0	       ; Ende Skalierliste

	
	.QPHRASE
lens_r1_scale:
        dc.w    $20            ;remainder
        dc.b    7
        dc.b    7
       	dc.l	0	

	
	.QPHRASE
s_cra_scale1:
	rept 3
	dc.w    $20            ;remainder
        dc.b    32
        dc.b    32

	dc.w    $20            ;remainder
        dc.b    32
        dc.b    32

	dc.w    $20            ;remainder
        dc.b    31
        dc.b    31
        
        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31

	dc.w    $20            ;remainder
        dc.b    30
        dc.b    30	
	
	dc.w    $20            ;remainder
        dc.b    30
        dc.b    30
	
	dc.w    $20            ;remainder
        dc.b    29
        dc.b    29
	
	dc.w    $20            ;remainder
        dc.b    29
        dc.b    29
        
	dc.w    $20            ;remainder
        dc.b    28
        dc.b    28
	
	dc.w    $20            ;remainder
        dc.b    28
        dc.b    28
	
	dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
	
	dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
	
	dc.w    $20            ;remainder
        dc.b    26
        dc.b    26
	
	dc.w    $20            ;remainder
        dc.b    26
        dc.b    26
        
        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
			
	dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
	
	dc.w    $20            ;remainder
        dc.b    24
        dc.b    24        
        
        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24
	
	dc.w    $20            ;remainder
        dc.b    23
        dc.b    23

	dc.w    $20            ;remainder
        dc.b    23
        dc.b    23
        
        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
        
        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22

	dc.w    $20            ;remainder
        dc.b    21
        dc.b    21

	dc.w    $20            ;remainder
        dc.b    21
        dc.b    21
        
        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
	
	dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
	
	dc.w    $20            ;remainder
        dc.b    23
        dc.b    23
        
        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24
        
        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
        
        dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
        
        dc.w    $20            ;remainder
        dc.b    29
        dc.b    29
        
        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30
	
	dc.w    $20            ;remainder
        dc.b    31
        dc.b    31
        
        dc.w    $20            ;remainder
        dc.b    32
        dc.b    32
	endr
	dc.l	0		; Ende Skalierliste


	.QPHRASE
s_cra_scale2:
	rept 3
	dc.w    $20            ;remainder
        dc.b    21
        dc.b    21

	dc.w    $20            ;remainder
        dc.b    22
        dc.b    22

	dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
        
        dc.w    $20            ;remainder
        dc.b    23
        dc.b    23

	dc.w    $20            ;remainder
        dc.b    23
        dc.b    23	
	
	dc.w    $20            ;remainder
        dc.b    24
        dc.b    24
	
	dc.w    $20            ;remainder
        dc.b    24
        dc.b    24
	
	dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
        
	dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
	
	dc.w    $20            ;remainder
        dc.b    26
        dc.b    26
        	
	dc.w    $20            ;remainder
        dc.b    26
        dc.b    26
	
	dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
	
	dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
	
	dc.w    $20            ;remainder
        dc.b    28
        dc.b    28
        
        dc.w    $20            ;remainder
        dc.b    28
        dc.b    28
			
	dc.w    $20            ;remainder
        dc.b    29
        dc.b    29
	
	dc.w    $20            ;remainder
        dc.b    29
        dc.b    29        
        
        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30
	
	dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

	dc.w    $20            ;remainder
        dc.b    31
        dc.b    31
        
        dc.w    $20            ;remainder
        dc.b    32
        dc.b    32
        
        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31

	dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

	dc.w    $20            ;remainder
        dc.b    29
        dc.b    29
        
        dc.w    $20            ;remainder
        dc.b    28
        dc.b    28
	
	dc.w    $20            ;remainder
        dc.b    27
        dc.b    27
	
	dc.w    $20            ;remainder
        dc.b    26
        dc.b    26
        
        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25
        
        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24
        
        dc.w    $20            ;remainder
        dc.b    23
        dc.b    23
        
        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
        
        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22
	
	dc.w    $20            ;remainder
        dc.b    21
        dc.b    21
        
        dc.w    $20            ;remainder
        dc.b    21
        dc.b    21
	endr
	dc.l	0		; Ende Skalierliste


	.QPHRASE
q_bomb_scale:
        dc.w            $20
        dc.b            32
        dc.b            32
	
        dc.w            $20
        dc.b            31
        dc.b            31

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            4
        dc.b            4

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            0
        dc.b            0

; und zurck
        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            4
        dc.b            4
        
        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31
	dc.l 0

;	.QPHRASE
;nebel_scale:
 ;       dc.w            $20
  ;      dc.b            15		; y
   ;     dc.b            40		; x
;	dc.l 0

;	.QPHRASE
;gasglas_scale1:
;        dc.w            $20
;        dc.b            40		; y
;        dc.b            42		; x
;	dc.l		0

	
;	.QPHRASE
;nebel_scale2:
 ;       dc.w            $20
  ;      dc.b            18		; y
   ;     dc.b            30		; x
;	dc.l 		0	


	.QPHRASE
ball_scale:
        dc.w            $20
        dc.b            32
        dc.b            32
	
        dc.w            $20
        dc.b            31
        dc.b            31

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            4
        dc.b            4

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            0
        dc.b            0

; und zurck
        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            4
        dc.b            4
        
        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31
	dc.l 		0


	.QPHRASE
eye_scale:
        dc.w            $20
        dc.b            32
        dc.b            32
	
        dc.w            $20
        dc.b            31
        dc.b            31

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31
	dc.l 		0
	

	.QPHRASE
spike_scale:
	dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            4
        dc.b            4
        
        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31


        dc.w            $20
        dc.b            32
        dc.b            32
; vorgezoomt	
		
	rept 12
	dc.w            $20
        dc.b            31
        dc.b            31

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31
	endr
	
; und wieder weg		
        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20
	dc.l 		0


	.QPHRASE
point_scale:
        dc.w            $20
        dc.b            32
        dc.b            32
	
        dc.w            $20
        dc.b            31
        dc.b            31

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            24
        dc.b            24

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            4
        dc.b            4

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            0
        dc.b            0

; und zurck
        dc.w            $20
        dc.b            1
        dc.b            1

        dc.w            $20
        dc.b            2
        dc.b            2

        dc.w            $20
        dc.b            3
        dc.b            3

        dc.w            $20
        dc.b            4
        dc.b            4
        
        dc.w            $20
        dc.b            5
        dc.b            5

        dc.w            $20
        dc.b            6
        dc.b            6

        dc.w            $20
        dc.b            7
        dc.b            7

        dc.w            $20
        dc.b            8
        dc.b            8

        dc.w            $20
        dc.b            9
        dc.b            9

        dc.w            $20
        dc.b            10
        dc.b            10

        dc.w            $20
        dc.b            11
        dc.b            11

        dc.w            $20
        dc.b            12
        dc.b            12

        dc.w            $20
        dc.b            13
        dc.b            13

        dc.w            $20
        dc.b            14
        dc.b            14

        dc.w            $20
        dc.b            15
        dc.b            15

        dc.w            $20
        dc.b            16
        dc.b            16

        dc.w            $20
        dc.b            17
        dc.b            17

        dc.w            $20
        dc.b            18
        dc.b            18

        dc.w            $20
        dc.b            19
        dc.b            19

        dc.w            $20
        dc.b            20
        dc.b            20

        dc.w            $20
        dc.b            21
        dc.b            21

        dc.w            $20
        dc.b            22
        dc.b            22

        dc.w            $20
        dc.b            23
        dc.b            23

        dc.w            $20
        dc.b            24
        dc.b            24
        
        dc.w            $20
        dc.b            25
        dc.b            25

        dc.w            $20
        dc.b            26
        dc.b            26

        dc.w            $20
        dc.b            27
        dc.b            27

        dc.w            $20
        dc.b            28
        dc.b            28

        dc.w            $20
        dc.b            29
        dc.b            29

        dc.w            $20
        dc.b            30
        dc.b            30

        dc.w            $20
        dc.b            31
        dc.b            31
	dc.l  0
		

;	.QPHRASE
;nebel_scale5:
 ;       dc.w            $20
  ;      dc.b            15		; y
   ;     dc.b            40		; x
;	dc.l 0

;-------------------------------------------------------------------------
; Kurvenlisten
;-------------------------------------------------------------------------

;	.QPHRASE
;back0_kurve:
;	rept 493 
 ;       dc.w   -1, 0
;	dc.w	0, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens_flare_kurve:
	rept 440 
        dc.w   -1, 0
	dc.w	0, 0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
planet_kurve:
	rept 473 
        dc.w   -1, 0
	dc.w	0, 0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
bright_kurve:
	rept	380
	dc.w	0, 0
	dc.w	0, 0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste	


	.QPHRASE
lens1_kurve:
	rept 500 
        dc.w	1, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens2_kurve:
	rept 500 
        dc.w	2, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens3_kurve:
	rept 550 
        dc.w	3, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens4_kurve:
	rept 400 
        dc.w	4, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens5_kurve:
	rept 500 
        dc.w	5, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
lens6_kurve:
	rept 400 
        dc.w	6, 0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


lens_r1_kurve:
	rept 360 
        dc.w	-2, 0
	endr
	dc.w	KURVE_ENDE
	
	
leiter_f_kurve:
	rept 151 
        dc.w	-3, 0
	endr
	dc.w	KURVE_ENDE


leiterbs_kurve:
	rept 180 
        dc.w	-2, 0
	endr
	dc.w	KURVE_ENDE


leiterq1_kurve:
	rept 261 
        dc.w	-2, 0
	endr
	dc.w	KURVE_ENDE



	.QPHRASE
s_cra_kurve1:
	DC.W   -1,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste

	.QPHRASE
s_cra_kurve2:
	DC.W   -1,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste




	.QPHRASE
schutz_kurve:
	DC.W    0,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -1,   1
	DC.W   -2,   3
	DC.W   -1,   1
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   1
	DC.W    1,   3
	DC.W    0,   2
	DC.W    1,   2
	DC.W    0,   1
	DC.W    1,   2
	DC.W    1,   2
	DC.W    1,   2
	DC.W    1,   2
	DC.W    2,   3
	DC.W    1,   1
	DC.W    2,   3
	DC.W    3,   2
	DC.W    3,   3
	DC.W    3,   3
	DC.W    3,   2
	DC.W    3,   1
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -3
	DC.W    2,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W    0,   0
	DC.W   -5,  -2
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -1,   1
	DC.W   -2,   3
	DC.W   -1,   1
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -2,   3
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   1
	DC.W    1,   3
	DC.W    0,   2
	DC.W    1,   2
	DC.W    0,   1
	DC.W    1,   2
	DC.W    1,   2
	DC.W    1,   2
	DC.W    1,   2
	DC.W    2,   3
	DC.W    1,   1
	DC.W    2,   3
	DC.W    3,   2
	DC.W    3,   3
	DC.W    3,   3
	DC.W    3,   2
	DC.W    3,   1
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -3
	DC.W    2,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W    0,   0
	DC.W   -4,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -2,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -2,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -2,   1
	dc.w	KURVE_ENDE	; Ende Kurvenliste


;treffer_kurve:
	dc.w	-0,0
	dc.w	-0,0
	dc.w	-0,0
	dc.w	-1,0
	dc.w	-0,0
	dc.w	-1,0
	dc.w	-0,0
	dc.w	-1,0
	dc.w	-0,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-2,0
	dc.w	-2,0
	dc.w	-2,0

	dc.w	-2,0
	dc.w	-2,0
	dc.w	-2,0
	dc.w	-2,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-3,0
	dc.w	-4,0
	dc.w	-4,0
	dc.w	-4,0
	dc.w	-4,0
	dc.w	-4,0
	dc.w	KURVE_ENDE	; Ende Kurvenliste



rocket_b_kurve: 	
	dc.w	-1, 0
	dc.w	 0, 0	
	dc.w	-1, 0
	dc.w	 0, 0
	dc.w	-1, 0
	dc.w	-1, 0
	dc.w	-1, 0
	dc.w	-2, 0
	dc.w	-1, 0
	dc.w	-2, 0
	dc.w	-1, 0
	dc.w	-2, 0
	dc.w	-2, 0
	dc.w	-2, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-3, 0
	dc.w	-4, 0
	dc.w	-3, 0
	dc.w	-4, 0
	dc.w	-4, 0
	dc.w	-4, 0
	dc.w	-4, 0
	dc.w	-4, 0
	dc.w	-4, 0
	dc.w	-5, 0
	dc.w	-4, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-5, 0
	dc.w	-6, 0
	dc.w	-5, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-6, 0
	dc.w	-7, 0
	dc.w	-6, 0
	dc.w	-7, 0
	dc.w	-6, 0
	dc.w	-7, 0
	dc.w	-7, 0
	dc.w	-7, 0
	dc.w	-7, 0
	dc.w	-7, 0
	dc.w	-7, 0
	dc.w	-8, 0
	dc.w	-7, 0
	dc.w	-8, 0
	dc.w	-7, 0
	dc.w	-8, 0
	dc.w	-8, 0
	dc.w	-8, 0
	dc.w	-8, 0
	dc.w	-8, 0
	dc.w	KURVE_ENDE	; Ende Kurvenliste




schutz_kurve2:
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -3,  -3
	DC.W   -3,  -3
	DC.W   -3,  -3
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   1
	DC.W    1,   3
	DC.W    0,   1
	DC.W    1,   2
	DC.W    1,   2
	DC.W    0,   1
	DC.W    1,   2
	DC.W    1,   2
	DC.W    2,   3
	DC.W    2,   3
	DC.W    3,   3
	DC.W    3,   3
	DC.W    3,   3
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -2
	DC.W    3,  -1
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -1
	DC.W    3,  -2
	DC.W    2,  -3
	DC.W    2,  -3
	DC.W    0,   0
	DC.W    0,   0
	DC.W    0,   0
	DC.W   -1,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -2,  -3
	DC.W   -1,  -3
	DC.W   -3,  -3
	DC.W   -3,  -3
	DC.W   -3,  -3
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


schutz_kurve3:
	DC.W    0,   1
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   3
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   2
	DC.W   -1,   3
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -2,   3
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -2,   3
	DC.W   -1,   1
	DC.W   -2,   3
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -2,   3
	DC.W   -2,   2
	DC.W   -2,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -3
	DC.W   -3,  -3
	DC.W   -2,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W   -1,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    0,  -3
	DC.W    1,  -3
	DC.W    0,  -3
	DC.W    2,  -3
	DC.W    1,  -3
	DC.W    1,  -3
	DC.W    2,  -3
	DC.W    3,  -3
	DC.W    3,  -3
	DC.W    3,  -3
	DC.W    3,  -3
	DC.W    3,  -2
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,  -1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   0
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   1
	DC.W    3,   2
	DC.W    3,   1
	DC.W    3,   2
	DC.W    3,   1
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    2,   3
	DC.W    1,   1
	DC.W    0,   1
	DC.W    0,   0
	DC.W    3,   3
	DC.W    0,   1
	DC.W    1,   2
	DC.W    1,   2
	DC.W    1,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   2
	DC.W    0,   1
	DC.W   -1,   3
	DC.W    0,   1
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W    0,   1
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -1,   2
	DC.W   -2,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


b_mike_kurve:
; obere Halbwelle
	
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	
	
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	
	
; untere Halbwelle
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3	
	
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
		
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2	
	
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2	
		
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3	
	
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
			
; Ende unten

	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	DC.W   -2,  -3
	
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	DC.W   -2,  -1
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	DC.W   -2,  1
	
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	
	
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
	DC.W   -2,  3
		
	dc.w	KURVE_ENDE	; Ende Kurvenliste



pfeil_oben_kurve:
	DC.W    0,   0
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -1,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste

pfeil_unten_kurve:
	DC.W    0,   0
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -1,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
meteor1_kurve:
	rept	360/5
	dc.w	-5, 0
	endr	
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/5
	dc.w	-5, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/5
	dc.w	-5, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/5
	dc.w	-5, 0
	endr	
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/5
	dc.w	-5, 0
	endr	
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
meteor1x_kurve:
	rept	360/5
	dc.w	-5, 0
	endr	
	rept	360/5
	dc.w	-5, 0
	endr	
	dc.w	KURVE_ENDE	; Ende Kurvenliste
	
	
	.QPHRASE
meteor2_kurve:
	rept	360/4
	dc.w	-4, 0
	endr	
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/4
	dc.w	-4, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/4
	dc.w	-4, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/4
	dc.w	-4, 0
	endr	
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/4
	dc.w	-4, 0
	endr	
	dc.w	KURVE_ENDE	; Ende Kurvenliste

	

	.QPHRASE
meteor3_kurve:
	rept	360/3
	dc.w	-3, 0
	endr	
	dc.w	360,0
	rept	360/3
	dc.w	-3, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/3
	dc.w	-3, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/3
	dc.w	-3, 0
	endr	
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
meteor4_kurve:
	rept	360/2
	dc.w	-2, 0
	endr	
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/2
	dc.w	-2, 0
	endr
	dc.w	360,0			; Wieder an den rechten Rand
	rept	360/2
	dc.w	-2, 0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


;	.QPHRASE
;gesch1_kurve:
;	rept 375
;	DC.W   -1,   0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste

	
	
;	.QPHRASE
;nebel_kurve:
;	rept 215 
 ;       dc.w   -2, 0
;	dc.w   -1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
	
	
	
;	.QPHRASE
;nebel_kurve2:
;	rept 215 
 ;       dc.w   -3, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
		
		
;	.QPHRASE
;nebel_kurve3:
;	rept 161 
 ;       dc.w   -4, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
				
	
	
;	.QPHRASE
;zahn_gross_kurve:
;	rept 430 
;        dc.w   -1, 0
;	dc.w	0, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste

;	.QPHRASE
;zahn_klein_kurve:
;	rept 430 
 ;       dc.w   -1, 0
;	dc.w	0, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
crawler_kurve_o:
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   6
	DC.W   -3,   6
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste

	
	
	.QPHRASE
crawler_kurve_u:
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -6
	DC.W   -3,  -6
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


;	.QPHRASE
;ape2_kurve:
;	rept (320+58)/2
;	DC.W   -2,   0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste



	.QPHRASE
q_bomb_kurve:
        rept	70
        dc.w    -2,0
        endr

	rept 6
	dc.w    0,0
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    1,2
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    1,1
	dc.w    0,1
 	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,2
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	dc.w    0,1
	dc.w    1,1
	endr
       

;	rept 30
 ;       dc.w   -3,-2
  ;      endr

	
;	rept 3
 ;       dc.w    0,0
  ;      dc.w    1,1
   ;     dc.w    0,1
    ;    dc.w    1,1
     ;   dc.w    0,1
      ;  dc.w    1,1
       ; dc.w    0,1
;        dc.w    1,1
 ;       dc.w    1,2
  ;      dc.w    0,1
   ;     dc.w    1,1
    ;    dc.w    0,1
     ;   dc.w    1,1
      ;  dc.w    0,1
       ; dc.w    1,1
;        dc.w    0,1
 ;       dc.w    1,1
  ;      dc.w    1,1
   ;     dc.w    0,1
    ;    dc.w    1,1
     ;   dc.w    0,1
      ;  dc.w    1,1
       ; dc.w    0,1
;        dc.w    1,2
 ;       dc.w    0,1
  ;      dc.w    1,1
  ;      dc.w    0,1
   ;     dc.w    1,1
    ;    dc.w    0,1
     ;   dc.w    1,1
      ;  dc.w    0,1
       ; dc.w    1,1
        ;endr
	
;	rept 116
 ;       dc.w   -1,-1
  ;      dc.w	0,-1
    ;    endr
        dc.w    KURVE_ENDE

       
;	.QPHRASE
;ape_kurve:
;	rept 123 
 ;       dc.w  -2, 0
;	dc.w  -1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
		
	
;	.QPHRASE
;gasglas_kurve:
;	rept 349 
 ;       dc.w   -1, 0
;	dc.w	0, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste


;	.QPHRASE
;hugger_kurve:
;	rept 361 
 ;       dc.w   -1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste


;	.QPHRASE
;glas_kurve:
;	rept 365 
 ;       dc.w   -1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste



	.QPHRASE
eye_kurve_o:
	DC.W   -2,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	dc.w	KURVE_ENDE
	
	
	
	
	.QPHRASE
eye_kurve_u:
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -1,  -2
	dc.w	KURVE_ENDE



	.QPHRASE
ball_kurve:
	DC.W   -2,   2
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -2,   2
	DC.W   -2,  -2
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -2,   0
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -1,   0
	dc.w	KURVE_ENDE


	.QPHRASE
eye2_kurve_o:
	DC.W    2,   2
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   6
	DC.W    2,   4
	DC.W    1,   4
	DC.W    1,   4
	DC.W    2,   6
	DC.W    1,   4
	DC.W    0,   2
	DC.W    1,   6
	DC.W    0,   4
	DC.W    1,   6
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -2,   6
	DC.W   -3,   6
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -2,   6
	DC.W   -1,   6
	DC.W    0,   4
	DC.W    1,   4
	DC.W    1,   4
	DC.W    2,   6
	DC.W    1,   2
	DC.W    2,   6
	DC.W    3,   4
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   0
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   2
	DC.W    3,   4
	DC.W    3,   2
	DC.W    3,   4
	DC.W    3,   6
	DC.W    3,   4
	DC.W    3,   6
	DC.W    3,   6
	DC.W    2,   6
	DC.W    0,   2
	DC.W    1,   6
	DC.W    0,   2
	DC.W    1,   6
	DC.W    0,   6
	DC.W    0,   2
	DC.W   -2,   6
	DC.W   -2,   6
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -1,   0
	dc.w	KURVE_ENDE
	
	
	
	
	.QPHRASE
eye2_kurve_u:
	DC.W    1,  -2
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -6
	DC.W    2,  -6
	DC.W    2,  -6
	DC.W    2,  -6
	DC.W    1,  -6
	DC.W    1,  -6
	DC.W    0,  -6
	DC.W    1,  -6
	DC.W    0,  -6
	DC.W   -2,  -6
	DC.W   -2,  -6
	DC.W   -3,  -6
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   6
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,  -4
	DC.W   -2,  -6
	DC.W   -2,  -6
	DC.W   -2,  -6
	DC.W    0,  -6
	DC.W    1,  -6
	DC.W    2,  -6
	DC.W    2,  -6
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,   0
	DC.W    3,  -2
	DC.W    3,  -2
	DC.W    3,  -4
	DC.W    3,  -2
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -4
	DC.W    3,  -6
	DC.W    3,  -6
	DC.W    2,  -6
	DC.W    2,  -6
	DC.W    1,  -6
	DC.W    1,  -6
	DC.W    0,  -6
	DC.W    0,  -6
	DC.W   -2,  -6
	DC.W   -3,  -6
	DC.W   -3,  -4
	DC.W   -3,  -6
	DC.W   -3,  -2
	DC.W   -3,  -4
	DC.W   -3,   0
	DC.W   -3,  -2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   4
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	dc.w	KURVE_ENDE
	
	
	.QPHRASE
spike_kurve:
	rept 31
	DC.W    0,  0	
	endr
	
	rept 360
	DC.W   -1,  0
	endr
	dc.w	KURVE_ENDE
	
	
	.QPHRASE
rotg_kurve:
	rept 100
	DC.W    0,   3
	endr	
	
	rept 80
	DC.W    0,   0
	endr
	
	DC.W    -1,  0
	DC.W     0,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	
	rept 30
	DC.W    -4,  0
	endr
	
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	
	rept 6
	DC.W    -5,  0
	endr
	dc.w	KURVE_ENDE
	

	.QPHRASE
rotg_kurve2:
	DC.W    -1,  0
	DC.W     0,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	
	rept 30
	DC.W    -4,  0
	endr
	
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	
	rept 16
	DC.W    -5,  0
	endr
	
	dc.w	KURVE_ENDE
	



	.QPHRASE
rotg_kurve3:
	rept 100
	DC.W    0,  -3
	endr	
	
	rept 80
	DC.W    0,   0
	endr
	
	DC.W    -1,  0
	DC.W     0,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -1,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -2,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	DC.W    -3,  0
	DC.W    -4,  0
	
	rept 30
	DC.W    -4,  0
	endr
	
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	DC.W    -5,  0
	DC.W    -4,  0
	
	rept 6
	DC.W    -5,  0
	endr
	dc.w	KURVE_ENDE
	
	
;	.QPHRASE
;haltglas_kurve:	
;	rept 374
;	DC.W    -1,  0
;	endr
;	dc.w	KURVE_ENDE

	
;	.QPHRASE
;kolben_kurve:
;	rept 350 
 ;       DC.W   -1,  0
  ;      DC.W	0,  0	
   ; 	endr
;	dc.w	KURVE_ENDE

;	.QPHRASE
;pleuel_kurve:
;	rept 354
 ;       DC.W    -1,  0
  ;  	DC.W	 0,  0
   ; 	endr
    ;	dc.w	KURVE_ENDE



;Presse oben nach unten
	
;	.QPHRASE
;presse_kurve1: 
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
	
;;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	dc.w	KURVE_ENDE
;

;	.QPHRASE
;presse_kurve2: 
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,3		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;;	rept 60
;;	dc.w	-1,-1		; 30 Pixel links, 30 Pixel nach oben
;	endr
;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,3		; 30 Pixel links, 30 Pixel nach unten
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,-1		; 30 Pixel links, 30 Pixel nach oben
;	endr
;	dc.w	KURVE_ENDE	
;


;	.QPHRASE
;presse_kurve3: 
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;	dc.w	KURVE_ENDE
;
;
;
;	.QPHRASE	
;presse_kurve4: 
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,-1		; 30 Pixel links, 30 Pixel nach oben
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,3		; 30 Pixel links, 30 Pixel nach unten
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,-1		; 30 Pixel links, 30 Pixel nach oben
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,3		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	dc.w	KURVE_ENDE	
;
;	.QPHRASE
;m_end_kurve:
;	rept 376
 ;       DC.W    -1,  0
  ;  	DC.W	 0,  0
   ; 	endr
    ;	dc.w	KURVE_ENDE


	.QPHRASE
point_kurve:
        
        rept 15
        dc.w    -3,0
	endr
	
	dc.w	-3,0
	dc.w	-2,0
	dc.w	-3,0
	dc.w	-2,0
	dc.w	-3,0
	dc.w	-2,0
	dc.w	-3,0
	dc.w	-2,0
	
	rept 20
        dc.w    -2,0
	endr
	
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	dc.w	-2,0
	dc.w	-1,0
	
	rept 220
        dc.w    -1,0
	endr
	dc.w    KURVE_ENDE

	
; 	.QPHRASE
;schlauch_kurve1: 
;	rept 76
;	dc.w	-1,0		; 76 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	dc.w	KURVE_ENDE
;
;
; 	
 ;	.QPHRASE
;schlauch_kurve2: 
;	rept 345
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	dc.w	KURVE_ENDE



;
;	.QPHRASE
;schlauch_kurve3: 
;	rept 76
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;	
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 60
;	dc.w	-1,1		; 30 Pixel links, 30 Pixel nach unten
;	endr
;;		
;	rept 60
;	dc.w	-1,0		; 60 Pixel links
;	endr
;	
;	rept 20
;	dc.w	-1,-3		; 30 Pixel links, 30 Pixel nach oben
;	endr
;	dc.w	KURVE_ENDE
	
;	.QPHRASE
;runner_kurve:
;	rept 45 
 ;       dc.w   -2, 0
;	dc.w   -1, 0
;	endr
;	
;	
;	dc.w   -3, -8
;	dc.w   -3, -8
;	dc.w   -3, -7
;	dc.w   -2, -8
;	dc.w   -3, -7
;	dc.w   -3, -8
;	dc.w   -3, -7
;	dc.w   -2, -7
;	dc.w   -3, -7
;	dc.w   -2, -6
;	dc.w   -2, -7
;	dc.w   -1, -6
;	dc.w   -1, -6
;	dc.w   -1, -6
;	dc.w   -1, -6
;	dc.w   -2, -5
;	dc.w   -1, -6
;	dc.w   -2, -5
;	dc.w   -1, -5
;	dc.w   -2, -5
;	dc.w   -1, -4
;	dc.w   -2, -5
;	dc.w   -1, -4
;	dc.w   -2, -5
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -2, -4
;	dc.w   -1, -4
;	dc.w   -1, -3
;	dc.w   -1, -4
;	dc.w   -1, -3
;	dc.w   -1, -3
;	dc.w   -1, -3
;	dc.w   -1, -3
;	dc.w   -1, -2
;	dc.w   -1, -3
;	dc.w   -1, -2
;	dc.w   -1, -3
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -2
;	dc.w   -1, -1
;	dc.w   -1, -2
;	dc.w   -1, -1
;	dc.w   -1, -2
;	dc.w   -1, -1
;	dc.w   -1, -2
;	dc.w   -1, -1
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1, -1
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  0
;	dc.w   -1,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	dc.w   -1,  0
;	dc.w   -2,  1
;	
;	rept 50
;	dc.w   -2,  1
;	endr
;	
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
;		
;				
				
;	.QPHRASE
;runner_kurve2:
;	rept 132 
 ;       dc.w   -1, 0
;	dc.w   -2, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste

;	.QPHRASE
;nebel_kurve5:
;	rept 640 
 ;       dc.w   1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste	
	
	
;	.QPHRASE
;nebel_kurve6:
;	rept 320 
 ;       dc.w   2, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste

	
	.QPHRASE
crawler_kurve:		
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -3
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -1
	DC.W   -3,  -2
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   3
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   2
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   1
	DC.W   -3,   2
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   1
	DC.W   -3,   0
	DC.W   -3,  -1
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0	
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste	
	
	
	
	
	.QPHRASE
crawler_kurve2:
	dc.w   -4, 0
	dc.w   -4, 0
	dc.w   -3, 0
	dc.w   -4, 0
	dc.w   -3, 0
	dc.w   -4, 0
	dc.w   -3, 0
	
	rept 20 
	dc.w   -3, 0
	endr
	
	dc.w   -2, 0
	dc.w   -3, 0
	dc.w   -2, 0
	dc.w   -3, 0
	dc.w   -2, 0
	dc.w   -3, 0
	dc.w   -2, 0
	
	rept 118 
	dc.w   -2, 0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
resort_kurve:
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    2,  -4
	DC.W    1,  -4
	DC.W    2,  -4
	DC.W    1,  -4
	DC.W    2,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   4
	DC.W   -2,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W    1,   4
	DC.W    1,   4
	DC.W    1,   2
	DC.W    1,   4
	DC.W    1,   2
	DC.W    1,   4
	DC.W    1,   4
	DC.W    0,   2
	DC.W    1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W    1,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -2,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   2
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W   -1,   4
	DC.W    0,   2
	DC.W   -1,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   2
	DC.W    1,   4
	DC.W    1,   4
	DC.W    1,   4
	DC.W    1,   4
	DC.W    2,   4
	DC.W    2,   4
	DC.W    2,   4
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -4
	DC.W    2,  -2
	DC.W    2,  -4
	DC.W    2,  -4
	DC.W    2,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W    1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W    0,  -4
	DC.W   -1,  -4
	DC.W   -2,  -4
	DC.W   -1,  -4
	DC.W   -2,  -2
	DC.W   -2,  -4
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -1,   0
	DC.W    0,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
resort_kurve2:
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  4
	DC.W   -2,  4
	DC.W   -2,  4
	DC.W   -2,  4
	DC.W   -1,  4
	DC.W   -2,  4
	DC.W   -1,  4
	DC.W   -2,  4
	DC.W    0,  4
	DC.W    0,  4
	DC.W   -1,  4
	DC.W    0,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    2,  4
	DC.W    1,  4
	DC.W    2,  4
	DC.W    1,  4
	DC.W    2,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    0,  4
	DC.W   -1,  4
	DC.W   -1,  4
	DC.W   -1,  4
	DC.W   -1,  4
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  2
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  0
	DC.W   -2,  2
	DC.W   -2,  0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -2
	DC.W   -2,   -4
	DC.W   -2,   -4
	DC.W   -1,   -4
	DC.W   -1,   -2
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W    0,   -4
	DC.W    0,   -2
	DC.W    1,   -4
	DC.W    1,   -4
	DC.W    1,   -2
	DC.W    1,   -4
	DC.W    1,   -2
	DC.W    1,   -4
	DC.W    1,   -4
	DC.W    0,   -2
	DC.W    1,   -4
	DC.W    0,   -4
	DC.W    0,   -2
	DC.W    1,   -4
	DC.W    0,   -4
	DC.W    0,   -2
	DC.W   -1,   -4
	DC.W    0,   -4
	DC.W   -1,   -4
	DC.W    0,   -4
	DC.W   -1,   -4
	DC.W    0,   -2
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W   -2,   -4
	DC.W   -1,   -2
	DC.W   -1,   -4
	DC.W   -1,   -2
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W   -1,   -2
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W   -1,   -4
	DC.W    0,   -2
	DC.W   -1,   -4
	DC.W    0,   -4
	DC.W    0,   -4
	DC.W    0,   -4
	DC.W    0,   -4
	DC.W    0,   -4
	DC.W    0,   -2
	DC.W    1,   -4
	DC.W    1,   -4
	DC.W    1,   -4
	DC.W    1,   -4
	DC.W    2,   -4
	DC.W    2,   -4
	DC.W    2,   -4
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   0
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   0
	DC.W    2,   -2
	DC.W    2,   -2
	DC.W    2,   0
	DC.W    2,   -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,   0
	DC.W    2,  2
	DC.W    2,  4
	DC.W    2,  2
	DC.W    2,  4
	DC.W    2,  4
	DC.W    2,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W    1,  4
	DC.W    0,  4
	DC.W   -1,  4
	DC.W    0,  4
	DC.W    0,  4
	DC.W    0,  4
	DC.W   -1,  4
	DC.W    0,  4
	DC.W   -1,  4
	DC.W   -2,  4
	DC.W   -1,  4
	DC.W   -2,  2
	DC.W   -2,  4
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,  2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -1,   0
	DC.W    0,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste				        
