;;======================================================================================*
;;											*
;;			Project Name	:	NATIVE SPIRIT				*
;;			Function	:	Explosion definitions			*
;;			FILENAME	:	PYROTECH.S				*
;;											*
;;			Programmer	:			             		*
;;			Release Date	:	07.06.97				*
;;											*
;;			COPYRIGHT 1996,1997,1998 Duranik Software			*
;;		  UNAUTHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION,			*
;;	  	 PERFORMANCE OR DISPLAY OF THIS COMPUTER PROGRAM OR			*
;;	 	THE ASSOCIATED AUDIOVISUAL WORK IS STRICTLY PROHIBITED.			*
;;				    ALL RIGHTS RESERVED.				*
;;											*
;;		REV.	DATE		AUTHOR		REVISION HISTORY		*
;;		~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~	~~~~~~~~~~~~~~~~~~~~~		*
;;		000	07.06.97	DURANIK?	Gegner.s 1st Release		*
;;		002...	12-05-07	Zentanyx	PYROTECH.S ... W.I.P.		*
;;											*
;;	Modification and Anomaly Report							*
;;	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~						*
;;	* Removed Bonuses change to explo2_daten for mech explosion (organics included) *
;;	* value/Punkte/EXTRA of geld/Tokens changed from 10 to 4			*
;;	* Explosion 6 n/a								*
;;											*
;;		   NATIVE SPIRIT Adaptation Produced by Jason Keith Data		*
;;	   This revision has been released under an Educational Community License	*
;;				Copyright  2007 Zentanyx				*
;;											*
;;======================================================================================*

; Definition fr R-Type Explosion
	.QPHRASE
rtype_explo:
exp1_x		set	-12
exp1_y		set	-40

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_rtype-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	1			; Anzahl Spritepos.
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	NBLR3JKD		; Spritedaten
	dc.w	16			; Hhe
	dc.w	32/4			; Breite (was 36/4)
	dc.w	32/4			; Offset (was 36/4)
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; Anzahl Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadresse Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Counter Schudaten
	dc.l	r_type_anim		; Adresse akt. Spriteliste
	dc.l	r_type_anim		; Startadresse Spriteliste
	dc.l	r_type_kurve2		; Start Kurvenliste
	dc.l	0			; Sample
	dc.w	7			; Energy R-Type
	dc.w	0			; EXTRA
	dc.l	rtype_explo		; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit in 60/x Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	32			; Breite Sprite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_rtype1-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	1			; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	arc			; Startadr. Spritedaten
	dc.w	32			; Hhe
	dc.w	32/4			; Breite
	dc.w	32/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	arc_anim		; Adr. akt. Spriteliste
	dc.l	arc_anim		; Startadresse Spriteliste
	dc.l	r_type_kurve2		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	32			; Breite Sprite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x			; X-Pos
	dc.w	exp1_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierungsangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k10_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

		
			
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k5_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+35		; X-Pos
	dc.w	exp1_y+20		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierungsangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k10_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln



	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+36		; X-Pos
	dc.w	exp1_y+32		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k8_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k6_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	8			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	0			; Reminder
	dc.b	0			; X-Scale
	dc.b	0			; Y-Scale
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k8_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln
	
	dc.l	0			; letzter Sprite


; Definition fr Explosion 1
	.QPHRASE
explo1_daten:
exp1_x		set	-12
exp1_y		set	-40
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x			; X-Pos
	dc.w	exp1_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierungsangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k10_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

		
			
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k5_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+35		; X-Pos
	dc.w	exp1_y+20		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierungsangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k10_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln



	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+36		; X-Pos
	dc.w	exp1_y+32		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k8_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k6_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	8			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+20		; X-Pos
	dc.w	exp1_y+5		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	0			; Reminder
	dc.b	0			; X-Scale
	dc.b	0			; Y-Scale
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k8_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln
	

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld2			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld2_anim		; Adr. akt. Spriteliste
	dc.l	geld2_anim		; Startadresse Spriteliste
	dc.l	geld_kurve2		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln
		
	dc.l	0			; letzter Sprite


; Definition fr Explosion 2
	.QPHRASE
explo2_daten:
exp2_x		set	-4
exp2_y		set	-14*2
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x			; X-Pos
	dc.w	exp2_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$17			; X-Scale
	dc.b	$10			; Y-Scale
	dc.l	explo_scale		; Adresse akt. Skalierangaben
	dc.l	explo_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x+0		; X-Pos
	dc.w	exp2_y+1		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x+0		; X-Pos
	dc.w	exp2_y+1		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x+3		; X-Pos
	dc.w	exp2_y+2		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierungsangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k10_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln

	
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x+15		; X-Pos
	dc.w	exp2_y+11		; Y-Pos
	dc.l	tr3			; Startadr. Spritedaten
	dc.w	17			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr3_anim		; Adr. akt. Spriteliste
	dc.l	tr3_anim		; Startadresse Spriteliste
	dc.l	k9_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			;


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x-10		; X-Pos
	dc.w	exp2_y-20		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; 


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x-10		; X-Pos
	dc.w	exp2_y-20		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr4_anim		; Adr. akt. Spriteliste
	dc.l	tr4_anim		; Startadresse Spriteliste
	dc.l	k5_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	8			; Breite


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x-10		; X-Pos
	dc.w	exp2_y-20		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	4			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	4			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp2_x-10		; X-Pos
	dc.w	exp2_y-20		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	4			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	4			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite



	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld_anim		; Adr. akt. Spriteliste
	dc.l	geld_anim		; Startadresse Spriteliste
	dc.l	geld_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln
	
	dc.l	0			; letzter Sprite


; Definition fr Explosion 3
	.QPHRASE
explo3_daten:
exp3_x		set	-16
exp3_y		set	-50

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp3_x			; X-Pos
	dc.w	exp3_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$12			; Y-Scale
	dc.l	explo_scale2		; Adresse akt. Skalierangaben
	dc.l	explo_scale2		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Breite


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp3_x+30		; X-Pos
	dc.w	exp3_y+52		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite
	
	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp3_x+30		; X-Pos
	dc.w	exp3_y+52		; Y-Pos
	dc.l	tr3			; Startadr. Spritedaten
	dc.w	17			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr3_anim		; Adr. akt. Spriteliste
	dc.l	tr3_anim		; Startadresse Spriteliste
	dc.l	k9_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp3_x+30		; X-Pos
	dc.w	exp3_y+52		; Y-Pos
	dc.l	tr6			; Startadr. Spritedaten
	dc.w	5			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr6_anim		; Adr. akt. Spriteliste
	dc.l	tr6_anim		; Startadresse Spriteliste
	dc.l	k3_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	8			; Breite


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp1_x+30		; X-Pos
	dc.w	exp1_y+26		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$11			; Y-Scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			; Breite in Pixeln



	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld2			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld2_anim		; Adr. akt. Spriteliste
	dc.l	geld2_anim		; Startadresse Spriteliste
	dc.l	geld_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln
		
	dc.l	0			; letzter Sprite


; Definition fr Explosion 4
	.QPHRASE
explo4_daten:
exp4_x		set	-4
exp4_y		set	-8

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x			; X-Pos
	dc.w	exp4_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$16			; Y-Scale
	dc.l	explo_scale4		; Adresse akt. Skalierangaben
	dc.l	explo_scale4		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Energieabzug bei Gegnerberhrung


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			;


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr4_anim		; Adr. akt. Spriteliste
	dc.l	tr4_anim		; Startadresse Spriteliste
	dc.l	k3_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	8			;



	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr6			; Startadr. Spritedaten
	dc.w	5			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr6_anim		; Adr. akt. Spriteliste
	dc.l	tr6_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	8			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+15		; X-Pos
	dc.w	exp4_y+16		; Y-Pos
	dc.l	tr3			; Startadr. Spritedaten
	dc.w	17			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr3_anim		; Adr. akt. Spriteliste
	dc.l	tr3_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			;


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+6		; X-Pos
	dc.w	exp4_y+12		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k8_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k6_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	1			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	1			; Geschwindigkeit fr Neustart
	dc.l	12			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+5		; X-Pos
	dc.w	exp4_y+0		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr4_anim		; Adr. akt. Spriteliste
	dc.l	tr4_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	8
	
	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+0		; X-Pos
	dc.w	exp4_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k2_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12


	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld2			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld2_anim		; Adr. akt. Spriteliste
	dc.l	geld2_anim		; Startadresse Spriteliste
	dc.l	geld_kurve2		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln

	dc.l	0			; letzter Sprite


; Definition fr Explosion 5
	.QPHRASE
explo5_daten:
exp5_x		set	-16
exp5_y		set	-50

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp5_x			; X-Pos
	dc.w	exp5_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$12			; Y-Scale
	dc.l	explo_scale		; Adresse akt. Skalierangaben
	dc.l	explo_scale2		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten#
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			; Breite in Pixeln


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp5_x+15		; X-Pos
	dc.w	exp5_y+16		; Y-Pos
	dc.l	tr3			; Startadr. Spritedaten
	dc.w	17			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr3_anim		; Adr. akt. Spriteliste
	dc.l	tr3_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			;


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp5_x+6		; X-Pos
	dc.w	exp5_y+12		; Y-Pos
	dc.l	tr2			; Startadr. Spritedaten
	dc.w	14			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr2_anim		; Adr. akt. Spriteliste
	dc.l	tr2_anim		; Startadresse Spriteliste
	dc.l	k6_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16


	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp5_x+0		; X-Pos
	dc.w	exp5_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	12			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp5_x+0		; X-Pos
	dc.w	exp5_y+6		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	1			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	1			; Geschwindigkeit fr Neustart
	dc.l	12			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp4_x+15		; X-Pos
	dc.w	exp4_y+16		; Y-Pos
	dc.l	tr3			; Startadr. Spritedaten
	dc.w	17			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l 	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr3_anim		; Adr. akt. Spriteliste
	dc.l	tr3_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			;
		
		
; Definition fr Geld 1
	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld_anim		; Adr. akt. Spriteliste
	dc.l	geld_anim		; Startadresse Spriteliste
	dc.l	geld_kurve2		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln

	dc.l	0			; letzter Sprite



;;;
;;; Explosion 6 was for gesch1k
;;;

; Definition fr Explosion 7
	.QPHRASE
explo7_daten:
exp7_x		set	-16
exp7_y		set	-50

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp7_x			; X-Pos
	dc.w	exp7_y			; Y-Pos
	dc.l	explo			; Startadr. Spritedaten
	dc.w	53			; Hhe
	dc.w	60/4			; Breite
	dc.w	60/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; Reminder
	dc.b	$11			; X-Scale
	dc.b	$12			; Y-Scale
	dc.l	explo_scale2		; Adresse akt. Skalierangaben
	dc.l	explo_scale2		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	explo_anim		; Adr. akt. Spriteliste
	dc.l	explo_anim		; Startadresse Spriteliste
	dc.l	explo_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	60			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp7_x+30		; X-Pos
	dc.w	exp7_y+50		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k9_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	1			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	1			; Geschwindigkeit fr Neustart
	dc.l	12			;



	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp7_x+30		; X-Pos
	dc.w	exp7_y+52		; Y-Pos
	dc.l	tr1			; Startadr. Spritedaten
	dc.w	10			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr1_anim		; Adr. akt. Spriteliste
	dc.l	tr1_anim		; Startadresse Spriteliste
	dc.l	k1_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	3			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	3			; Geschwindigkeit fr Neustart
	dc.l	12			;

	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp7_x+30		; X-Pos
	dc.w	exp7_y+50		; Y-Pos
	dc.l	tr5			; Startadr. Spritedaten
	dc.w	11			; Hhe
	dc.w	12/4			; Breite
	dc.w	12/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr5_anim		; Adr. akt. Spriteliste
	dc.l	tr5_anim		; Startadresse Spriteliste
	dc.l	k4_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	1			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	1			; Geschwindigkeit fr Neustart
	dc.l	12			;


	
	dc.l	1			; <> 0
	dc.w	(obj_explo-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXPLO		; frei wegen PHRASE alignment
	dc.w	exp7_x+30		; X-Pos
	dc.w	exp7_y+50		; Y-Pos
	dc.l	tr4			; Startadr. Spritedaten
	dc.w	7			; Hhe
	dc.w	8/4			; Breite
	dc.w	8/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	1			; Object Typ (Scaled Bitmap) 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.w 	$20			; reminder
	dc.b	$11			; x-scale
	dc.b	$11			; y-scale
	dc.l	tr_scale		; Adresse akt. Skalierangaben
	dc.l	tr_scale		; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	tr4_anim		; Adr. akt. Spriteliste
	dc.l	tr4_anim		; Startadresse Spriteliste
	dc.l	k7_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	0			; Extra
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	8			;

;;;
;;; TOKEN
;;;

	dc.l	1			; X-Pos wo Gegner erscheint
	dc.w	(obj_extra-obj_gegner)	; Vorder/Hintergrund Offset
	dc.w	TOTAL_EXTRA		; frei wegen PHRASE alignment
	dc.w	0			; X-Pos
	dc.w	0			; Y-Pos
	dc.l	geld2			; Startadr. Spritedaten
	dc.w	12			; Hhe
	dc.w	16/4			; Breite
	dc.w	16/4			; Offset
	dc.b	4			; Flags 4=transparent
	dc.b	0			; Firstpix
	dc.b	0			; Object Typ 
	dc.b	4			; 65535 Farben
	dc.b	1			; Pitch
	dc.b	0			; Index
	dc.l	0			; akt. Skalierangaben
	dc.l	0			; Adresse akt. Skalierangaben
	dc.l	0			; Startadr. Skalierangaben
	dc.l	0			; Startadresse Schudaten
	dc.l	0			; Schucounter
	dc.l	geld2_anim		; Adr. akt. Spriteliste
	dc.l	geld2_anim		; Startadresse Spriteliste
	dc.l	geld_kurve		; Start Flugbahn
	dc.l	0			; Sample
	dc.w	DESTROY			; ntige Feuerkraft um Gegner zu vernichten
	dc.w	4			; EXTRA
	dc.l	0			; Startadresse Daten Folgesprites
	dc.w	2			; Geschwindigkeit 30 Bilder pro Sekunde
	dc.w	2			; Geschwindigkeit fr Neustart
	dc.l	16			; Breite Sprite in Pixeln
		
	dc.l	0			; letzter Sprite


;;;
;;; Definition fr Explosion Orange Geschtz (oran_u_k removed)
;;;

;;;
;;; Definition fr Explosion Orange Geschtz (oran_o_k removed)
;;;
	
;;;
;;; Definition fr Bonussymbol "O" Explosion 3 (bonus_o & stern removed)
;;;

;;;
;;; Definition fr Bonussymbol "X" Explosion 1 (bonus_x & stern removed)
;;;	

;;;
;;; Definition fr DESTROY ALL (many sterns removed)
;;;

;-------------------------------------------------------------------------
; Animationslisten
;-------------------------------------------------------------------------
	.QPHRASE
arc_anim:
.i	set	0
	rept	10
	dc.l	arc+(32*32*2*.i)
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste
		

	.QPHRASE
explo_anim:
.i	set	0
	rept	24
	dc.l	explo+(60*53*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste

	.QPHRASE
tr1_anim:
.i	set	0
	rept	13
	dc.l	tr1+(12*10*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
tr2_anim:
.i	set	0
	rept	15
	dc.l	tr2+(16*14*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
tr3_anim:
.i	set	0
	rept	15
	dc.l	tr3+(16*17*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
tr4_anim:
.i	set	0
	rept	30
	dc.l	tr4+(8*7*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
tr5_anim:
.i	set	0
	rept	30
	dc.l	tr5+(12*11*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
tr6_anim:
.i	set	0
	rept	30
	dc.l	tr6+(8*5*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
geld_anim:
.i	set	0
	rept	20
	dc.l	geld+(16*12*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


	.QPHRASE
geld2_anim:
.i	set	0
	rept	20
	dc.l	geld2+(16*12*2*.i)		
.i	set	.i+1
	endr
	dc.l	0		; Ende Animationsliste


;	.QPHRASE
;gesch1k_anim:
;	dc.l	gesch1k		
;	dc.l	0		; Ende Animationsliste


;	.QPHRASE
;oran_u_k_anim:
;	dc.l	oran_u_k		
;	dc.l	0
	

;	.QPHRASE
;oran_o_k_anim:
;	dc.l	oran_o_k		
;	dc.l	0	


;	.QPHRASE
;bonus_o_anim:
;.i	set	0
;	rept	19
;	dc.l	bonus_o+(16*16*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0		; Ende Animationsliste


;	.QPHRASE
;bonus_x_anim:
;.i	set	0
;	rept	19
;	dc.l	bonus_x+(16*16*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0		; Ende Animationsliste


;	.QPHRASE
;stern_anim:
;.i	set	0
;	rept	11
;	dc.l	stern+(32*32*2*.i)		
;.i	set	.i+1
;	endr
;	dc.l	0		; Ende Animationsliste

;-------------------------------------------------------------------------
; Skalierlisten
;-------------------------------------------------------------------------
	.QPHRASE
tr_scale:
     	dc.w    $20            ;remainder
        dc.b    21
        dc.b    21

        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22

        dc.w    $20            ;remainder
        dc.b    23
        dc.b    23

        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24

        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25

        dc.w    $20            ;remainder
        dc.b    26
        dc.b    26

        dc.w    $20            ;remainder
        dc.b    27
        dc.b    27

        dc.w    $20            ;remainder
        dc.b    28
        dc.b    28

        dc.w    $20            ;remainder
        dc.b    29
        dc.b    29

        dc.w    $20            ;remainder
        dc.b    29
        dc.b    29

        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31

        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31
      
        dc.w    $20            ;remainder
        dc.b    32            ;x-scale
        dc.b    32            ;y-scale

        dc.w    $20            ;remainder
        dc.b    32
        dc.b    32

        dc.w    $20            ;remainder
        dc.b    33
        dc.b    33

        dc.w    $20            ;remainder
        dc.b    33
        dc.b    33

        dc.w    $20            ;remainder
        dc.b    34
        dc.b    34
       
        dc.w    $20            ;remainder
        dc.b    35
        dc.b    35

        dc.w    $20            ;remainder
        dc.b    36
        dc.b    36

        dc.w    $20            ;remainder
        dc.b    36
        dc.b    36

        dc.w    $20            ;remainder
        dc.b    37
        dc.b    37

        dc.w    $20            ;remainder
        dc.b    37
        dc.b    37

        dc.w    $20            ;remainder
        dc.b    38
        dc.b    38

        dc.w    $20            ;remainder
        dc.b    38
        dc.b    38

        dc.w    $20            ;remainder
        dc.b    38
        dc.b    38

        dc.w    $20            ;remainder
        dc.b    38
        dc.b    38

        dc.w    $20            ;remainder
        dc.b    39
        dc.b    39

        dc.w    $20            ;remainder
        dc.b    39
        dc.b    39

        dc.w    $20            ;remainder
        dc.b    40
        dc.b    40

        dc.w    $20            ;remainder
        dc.b    40
        dc.b    40

        dc.w    $20            ;remainder
        dc.b    41
        dc.b    41

        dc.w    $20            ;remainder
        dc.b    41
        dc.b    41

        dc.w    $20            ;remainder
        dc.b    42
        dc.b    42

        dc.w    $20            ;remainder
        dc.b    42
        dc.b    42

        dc.w    $20            ;remainder
        dc.b    43
        dc.b    43

        dc.w    $20            ;remainder
        dc.b    43
        dc.b    43

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    46
        dc.b    46

        dc.w    $20            ;remainder
        dc.b    46
        dc.b    46

        dc.w    $20            ;remainder
        dc.b    47
        dc.b    47

        dc.w    $20            ;remainder
        dc.b    47
        dc.b    47

        dc.w    $20            ;remainder
        dc.b    48
        dc.b    48

        dc.w    $20            ;remainder
        dc.b    48
        dc.b    48

        dc.w    $20            ;remainder
        dc.b    49
        dc.b    49

        dc.w    $20            ;remainder
        dc.b    49
        dc.b    49
        
        dc.w    $20            ;remainder
        dc.b    50
        dc.b    50

        dc.w    $20            ;remainder
        dc.b    50
        dc.b    50

        dc.w    $20            ;remainder
        dc.b    51
        dc.b    51

        dc.w    $20            ;remainder
        dc.b    51
        dc.b    51

        dc.w    $20            ;remainder
        dc.b    50
        dc.b    50

        dc.w    $20            ;remainder
        dc.b    50
        dc.b    50

        dc.w    $20            ;remainder
        dc.b    49
        dc.b    49

        dc.w    $20            ;remainder
        dc.b    49
        dc.b    49

        dc.w    $20            ;remainder
        dc.b    48
        dc.b    48

        dc.w    $20            ;remainder
        dc.b    48
        dc.b    48

        dc.w    $20            ;remainder
        dc.b    47
        dc.b    47

        dc.w    $20            ;remainder
        dc.b    47
        dc.b    47

        dc.w    $20            ;remainder
        dc.b    46
        dc.b    46

        dc.w    $20            ;remainder
        dc.b    46
        dc.b    46

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    45
        dc.b    45

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    44
        dc.b    44

        dc.w    $20            ;remainder
        dc.b    43
        dc.b    43

        dc.w    $20            ;remainder
        dc.b    43
        dc.b    43

        dc.w    $20            ;remainder
        dc.b    42
        dc.b    42

        dc.w    $20            ;remainder
        dc.b    42
        dc.b    42

        dc.w    $20            ;remainder
        dc.b    41
        dc.b    41

        dc.w    $20            ;remainder
        dc.b    41
        dc.b    41

        dc.w    $20            ;remainder
        dc.b    40
        dc.b    40

        dc.w    $20            ;remainder
        dc.b    40
        dc.b    40

        dc.w    $20            ;remainder
        dc.b    39
        dc.b    39

        dc.w    $20            ;remainder
        dc.b    39
        dc.b    39

        dc.w    $20            ;remainder
        dc.b    38
        dc.b    38

        dc.w    $20            ;remainder
        dc.b    37
        dc.b    37

        dc.w    $20            ;remainder
        dc.b    37
        dc.b    37

        dc.w    $20            ;remainder
        dc.b    36
        dc.b    36

        dc.w    $20            ;remainder
        dc.b    36
        dc.b    36

        dc.w    $20            ;remainder
        dc.b    35
        dc.b    35

        dc.w    $20            ;remainder
        dc.b    35
        dc.b    35

        dc.w    $20            ;remainder
        dc.b    34
        dc.b    34

        dc.w    $20            ;remainder
        dc.b    34
        dc.b    34

        dc.w    $20            ;remainder
        dc.b    33
        dc.b    33

        dc.w    $20            ;remainder
        dc.b    33
        dc.b    33

        dc.w    $20            ;remainder
        dc.b    32
        dc.b    32

        dc.w    $20            ;remainder
        dc.b    32
        dc.b    32

        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31

        dc.w    $20            ;remainder
        dc.b    31
        dc.b    31

        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

        dc.w    $20            ;remainder
        dc.b    30
        dc.b    30

        dc.w    $20            ;remainder
        dc.b    29
        dc.b    29

        dc.w    $20            ;remainder
        dc.b    29
        dc.b    29

        dc.w    $20            ;remainder
        dc.b    28
        dc.b    28

        dc.w    $20            ;remainder
        dc.b    28
        dc.b    28

        dc.w    $20            ;remainder
        dc.b    27
        dc.b    27

        dc.w    $20            ;remainder
        dc.b    27
        dc.b    27

        dc.w    $20            ;remainder
        dc.b    26
        dc.b    26

        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25

        dc.w    $20            ;remainder
        dc.b    25
        dc.b    25

        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24

        dc.w    $20            ;remainder
        dc.b    24
        dc.b    24

        dc.w    $20            ;remainder
        dc.b    23
        dc.b    23

        dc.w    $20            ;remainder
        dc.b    23
        dc.b    23

        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22

        dc.w    $20            ;remainder
        dc.b    22
        dc.b    22

        dc.w    $20            ;remainder
        dc.b    21
        dc.b    21

        dc.w    $20            ;remainder
        dc.b    21
        dc.b    21

        dc.w    $20            ;remainder
        dc.b    20
        dc.b    20

        dc.w    $20            ;remainder
        dc.b    20
        dc.b    20

        dc.w    $20            ;remainder
        dc.b    19
        dc.b    19

        dc.w    $20            ;remainder
        dc.b    19
        dc.b    19

        dc.w    $20            ;remainder
        dc.b    18
        dc.b    18
	dc.l	0		; Ende Skalierliste

	.QPHRASE
explo_scale2:
	rept	2
	dc.w 	$20	;reminder
	dc.b	38	;x-scale
	dc.b	38	;y-scale
	endr
	dc.l	0		; Ende Skalierliste

	.QPHRASE
explo_scale:
	rept	2
	dc.w 	$20	;reminder
	dc.b	25	;x-scale
	dc.b	25	;y-scale
	endr
	dc.l	0		; Ende Skalierliste


	.QPHRASE
explo_scale4:
	rept	2
	dc.w 	$20	;reminder
	dc.b	$11	;x-scale
	dc.b	$16	;y-scale
	endr
	dc.l	0		; Ende Skalierliste


	.QPHRASE
explo_scale6:
	dc.w 	$20	;reminder
	dc.b	32	;x-scale
	dc.b	47	;y-scale
	dc.l	0		; Ende Skalierliste


;;;
;;; bonus_scale removed
;;;

;;;
;;; stern_scale removed
;;;

;;;
;;; stern_scale2 removed
;;;

;-------------------------------------------------------------------------
; Kurvenlisten
;-------------------------------------------------------------------------
	.QPHRASE
explo_kurve:
	rept 48 
        DC.W    0,   0
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste

	.QPHRASE
explo_kurve6:
	rept 48 
        DC.W    -1,  -1
    	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k1_kurve:
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k2_kurve:
	DC.W    3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,   0
	DC.W   -3,  -3
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k3_kurve:
	DC.W    4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	DC.W   -4,   4
	DC.W   -4,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k4_kurve:
	DC.W    3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   0
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	DC.W   -3,   3
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k5_kurve:
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k6_kurve:
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k7_kurve:
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    0,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    0,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    0,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    0,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    0,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   0
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	DC.W    1,   1
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k8_kurve:
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   3
	DC.W    3,   0
	DC.W    3,   0
	DC.W    3,   0
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k9_kurve:
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k10_kurve:
	DC.W    0,   2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
k11_kurve:
	DC.W    0,   2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W   -2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W   -2,  -2
	DC.W    0,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W    0,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,  -2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   0
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W   -2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    0,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   2
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,   0
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    2,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W    0,  -2
	DC.W   -2,  -2
	DC.W    0,  -2
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
geld_kurve:
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -3
	dc.w	0,  -4
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -2
	dc.w	0,  -3
	dc.w    0,  -2
	dc.w	0,  -2
	dc.w	0,  -3
	dc.w    0,  -2
	dc.w	0,  -2
	dc.w	0,  -2
	dc.w	0,  -2
	dc.w	0,  -2
	dc.w    0,  -1
	dc.w	0,  -2
	dc.w	0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w	0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w	0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W 	0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W 	0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W 	0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   3
	DC.W    0,   2
	DC.W    0,   3
	DC.W    0,   2
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3 
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   4
	DC.W    0,   3
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   5
	DC.W    0,   4
	DC.W    0,   5
	DC.W    0,   4
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	dc.w	KURVE_ENDE	; Ende Kurvenliste
	
	
	
	.QPHRASE
geld_kurve2:
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -4
	dc.w	0,  -3
	dc.w	0,  -4
	dc.w    0,  -3
	dc.w	0,  -4
	dc.w	0,  -3
	dc.w    0,  -3
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -3
	dc.w	0,  -2
	dc.w	0,  -2
	dc.w    0,  -2
	dc.w	0,  -2
	dc.w	0,  -2
	dc.w    0,  -2
	dc.w    0,  -2
	dc.w    0,  -2
	dc.w    0,  -2
	dc.w    0,  -1
	dc.w    0,  -2
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,  -1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	dc.w    0,   1
	dc.w    0,   0
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W 	0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W 	0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   1
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   2
	DC.W    0,   3
	DC.W    0,   2
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   3
	DC.W    0,   4
	DC.W    0,   3
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   4
	DC.W    0,   5
	DC.W    0,   4
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	DC.W    0,   5
	dc.w	KURVE_ENDE	; Ende Kurvenliste


;	.QPHRASE
;gesch1k_kurve:
;	rept 380 
 ;       DC.W    -1,   0
  ;  	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
		
	
;	.QPHRASE
;oran_kurve:
;	rept 341 
 ;       dc.w   -1, 0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
			

;	.QPHRASE
;bonus_kurve:
;	rept 118
;	DC.W   -2,   0
;	DC.W   -1,   0
;	endr
;	dc.w	KURVE_ENDE	; Ende Kurvenliste
						
		
	.QPHRASE
schnecke1_kurve:
	rept 40
	DC.W   -7,   0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
		
		
	.QPHRASE
schnecke2_kurve:
	rept 40
	DC.W    0,   8
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
	
	
	.QPHRASE
schnecke3_kurve:
	rept 40
	DC.W    7,   0
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
	
	
	.QPHRASE
schnecke4_kurve:
	rept 40
	DC.W    0,   -8
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste


	.QPHRASE
schnecke5_kurve:
	rept 40
	DC.W   -5,   5
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
		
		
	.QPHRASE
schnecke6_kurve:
	rept 40
	DC.W    5,   5
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
			
			
	.QPHRASE
schnecke7_kurve:
	rept 40
	DC.W    5,   -5
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
			

	.QPHRASE
schnecke8_kurve:
	rept 40
	DC.W   -5,   -5
	endr
	dc.w	KURVE_ENDE	; Ende Kurvenliste
